// //-------------------------------------------\\
// ||	Title:		Minigolf Client				||
// ||	Author:		Zapk, edited by Conan		||
// ||-------------------------------------------||
// ||	http://www.steamcommunity.com/id/Zapk	||
// ||-------------------------------------------||
// ||	https://github.com/Zapk					||
// \\-------------------------------------------//

//													Libraries
//													---------
exec( "./lib/Support_UpdaterDownload.cs" );		//	By Greek2Me
exec( "./lib/tango.cs" );						//	By Zapk

//													Source Modules
//													--------------
exec( "./src/main.cs" );						//	Main
exec( "./src/voting.cs" );						//	Voting System
exec( "./src/profiles.cs" );					//	GUI Profiles
exec( "./src/addition.cs" );					//	Conan's additions
exec( "./src/menu.cs" );					//	Jasa's shit

//													GUI Objects
//													-----------
if( !isObject( MinigolfHUD ) )					//	MinigolfHUD
{												//	-	Used for the in-game power HUD.
	exec( "./res/gui/MinigolfHUD.gui" );
}

if( !isObject( MinigolfScoresGui ) )			//	MinigolfScores
{												//	-	Used to display the end-of-hole score table.
	exec( "./res/gui/MinigolfScores.gui" );
}

if( !isObject( MinigolfVotingGui ) )			//	MinigolfVoting
{												//	-	Used to vote for what map you want next.
	exec( "./res/gui/MinigolfVoting.gui" );
}

if(!isObject(Minigolf_Menu))
{
	exec("./res/gui/MinigolfMenu.gui");
}

function MGC_Reload()
{
	exec( "./client.cs" );
}