$remapDivision[$remapCount] = "Minigolf";
$remapName[$remapCount] = "Open Minigolf Menu";
$remapCmd[$remapCount] = "clientCmdMGC_OpenMenu";
$remapCount++;
function Minigolf_LeaderBoardMenu()
{
	Minigolf_MenuLeaderboard.position = "530 60";
	Minigolf_SlideMenuIn(Minigolf_MenuLeaderboard,10,60);
	commandtoserver('MGC_getLeaderboard');
	Minigolf_MenuLeaderboard.setVisible(1);
	Minigolf_MenuCourses.setVisible(0);
	Minigolf_MenuCredits.setVisible(0);
	Minigolf_MenuGroups.setVisible(0);
}
function Minigolf_CreditsMenu()
{
	Minigolf_MenuLogo.mColor = "255 255 255 0";
	Minigolf_MenuCredits.position = "-510 60";
	Minigolf_SlideMenuIn(Minigolf_MenuCredits,10,60);
	schedule(500,0,"Minigolf_FadeImageIn",Minigolf_MenuLogo);
	Minigolf_MenuLeaderboard.setVisible(0);
	Minigolf_MenuCourses.setVisible(0);
	Minigolf_MenuCredits.setVisible(1);
	Minigolf_MenuGroups.setVisible(0);
}
function Minigolf_GroupsMenu()
{
	Minigolf_MenuGroups.position = "-510 60";
	Minigolf_SlideMenuIn(Minigolf_MenuGroups,10,60);
	Minigolf_MenuGroups.GetObject(1).position = "-180 50";
	schedule(400,0,"Minigolf_SlideMenuIn",Minigolf_MenuGroups.GetObject(1),10,50);
	Minigolf_MenuGroups.GetObject(3).position = "690 50";
	schedule(400,0,"Minigolf_SlideMenuIn",Minigolf_MenuGroups.GetObject(3),330,50);
	commandtoserver('MGC_getGroups');
	Minigolf_MenuLeaderboard.setVisible(0);
	Minigolf_MenuCourses.setVisible(0);
	Minigolf_MenuCredits.setVisible(0);
	Minigolf_MenuGroups.setVisible(1);
}
function Minigolf_CoursesMenu()
{
	Minigolf_PlayCourse.position = "25 290";
	schedule(400,0,"Minigolf_SlideButtonIn",Minigolf_PlayCourse,25,220);
	Minigolf_CourseIcon.mColor = "255 255 255 0";
	schedule(400,0,"Minigolf_FadeImageIn",Minigolf_CourseIcon);
	Minigolf_MenuCourses.position = "530 60";
	Minigolf_SlideMenuIn(Minigolf_MenuCourses,10,60);
	commandtoserver('MGC_getCourses');
	Minigolf_MenuLeaderboard.setVisible(0);
	Minigolf_MenuCourses.setVisible(1);
	Minigolf_MenuCredits.setVisible(0);
	Minigolf_MenuGroups.setVisible(0);
}
function clientCmdMGC_OpenMenu(%bool)
{
	if(%bool !$= "0")
		canvas.pushdialog(Minigolf_Menu);
}
function Minigolf_FadeImageIn(%image)
{
	if(isObject(%image))
	{
		%alpha = getWord(%image.mColor,3);
		if(%alpha < 255)
		{
			%alpha+=4;
			if(%alpha > 255)
				%alpha = 255;
			%image.mColor = "255 255 255 "@ %alpha;
			schedule(16,0,"Minigolf_FadeImageIn",%image);
		}
	}
}
function Minigolf_SlideMenuIn(%menu,%targetx,%targety)
{
	if(isObject(%menu))
	{
		%currx = getWord(%menu.position,0);
		%xdist = %currx - %targetx;
		if(%xdist > 1)
		{
			%menu.position = %currx-mCeil(%xdist*0.1) SPC %targety;
			schedule(16,0,"Minigolf_slideMenuIn",%menu,%targetx,%targety);
		}
		else if(%xdist < -1)
		{
			%menu.position = %currx-mFloor(%xdist*0.1) SPC %targety;
			schedule(16,0,"Minigolf_slideMenuIn",%menu,%targetx,%targety);
		}
		else
			%menu.position = %targetx SPC %targety;
	}
}
function Minigolf_SlideButtonIn(%obj,%targetx,%targety)
{
	%curry = getWord(%obj.position,1);
	%ydist = %curry - %targety;
	if(%ydist > 1)
	{
		%obj.position = %targetx SPC %curry-mCeil(%ydist*0.1);
		schedule(16,0,"MiniGolf_SlideButtonIn",%obj,%targetx,%targety);
	}
}
function clientCmdMGC_CourseInit()
{
	Minigolf_CourseScrollSwatch.extent = "250 1";
	Minigolf_PlayCourse.setVisible(0);
	Minigolf_CourseIcon.setVisible(0);
	%count = Minigolf_CourseScrollSwatch.getCount();
	while(%count)
	{
		miniGolf_CourseScrollSwatch.getObject(0).delete();
		%count = Minigolf_CourseScrollSwatch.getCount();
	}
}

$MGC::CourseColor1 = "100 100 100 255";
$MGC::CourseColor2 = "0 0 0 255";
$MGC::CourseBGColor = "200 200 200 255";
$MGC::CourseHLColor = "64 64 64 255";
function clientCmdMGC_AddCourse(%name,%players,%par,%difficulty,%color1,%color2,%description1,%description2)
{
	if(getWordCount(%color1) != 4)
		%color1 = $MGC::CourseColor1;
	if(getWordCount(%color2) != 4)
		%color2 = $MGC::CourseColor2;
	if(%difficulty $= "")
		%difficulty = "N/A";
	%currcount = MiniGolf_CourseScrollSwatch.getCount();
	
	%new = new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "2 "@ %currcount*112+2;//Each item is 108 units high, let's put a 4PX gap between them
		extent = "240 108";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		color = $MGC::CourseBGColor;
		coursename = %name;
		new GuiSwatchCtrl()	//----------COURSE NAME----------
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "240 20";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = %color2;
                  	new GuiTextCtrl()
			{
				profile = "MGC_MenuCenter";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "240 20";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %name;
				maxLength = "255";
			};
		};
               	new GuiBitmapCtrl()	//----------PAR----------
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "90 20";	//Middle circle
			extent = "60 60";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			bitmap = "base/data/particles/dot.png";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			keepCached = "0";
			mColor = %color1;
			mMultiply = "0";
                 	new GuiTextCtrl()
			{
				profile = "MGC_MenuLeft";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "18 12";
				extent = "24 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Par";
				maxLength = "255";
			};
			new GuiTextCtrl()
			{
				profile = "MGC_MenuCenter";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "60 20";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %par;
				maxLength = "255";
			};
		};
               	new GuiBitmapCtrl()	//----------PLAYERS----------
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 20";	//Left circle
			extent = "60 60";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			bitmap = "base/data/particles/dot.png";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			keepCached = "0";
			mColor = %color1;
			mMultiply = "0";
                 	new GuiTextCtrl()
			{
				profile = "MGC_MenuLeft";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 12";
				extent = "50 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Players";
				maxLength = "255";
			};
			new GuiTextCtrl()
			{
				profile = "MGC_MenuCenter";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "60 20";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %players;
				maxLength = "255";
			};
		};
               	new GuiBitmapCtrl()	//----------DIFFICULTY----------
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "170 20";	//Right circle
			extent = "60 60";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			bitmap = "base/data/particles/dot.png";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			keepCached = "0";
			mColor = %color1;
			mMultiply = "0";
                 	new GuiTextCtrl()
			{
				profile = "MGC_MenuLeft";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 12";
				extent = "56 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Difficulty";
				maxLength = "255";
			};
			new GuiTextCtrl()
			{
				profile = "MGC_MenuCenter";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 30";
				extent = "60 20";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %difficulty;
				maxLength = "255";
			};
		};
		new GuiSwatchCtrl()	//----------DESCRIPTION----------
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 80";
			extent = "240 28";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = %color2;
                  	new GuiTextCtrl()
			{
				profile = "MGC_MenuDescription";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "240 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %description1;
				maxLength = "255";
			};
                  	new GuiTextCtrl()
			{
				profile = "MGC_MenuDescription";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 14";
				extent = "240 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %description2;
				maxLength = "255";
			};
		};
           	new GuiButtonBaseCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "240 108";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "MiniGolf_SelectCourse("@ %currcount @");";//Put an invisible button over everything this item
			groupNum = "-1";
			buttonType = "PushButton";
		};
	};
	MiniGolf_CourseScrollSwatch.add(%new);
	MiniGolf_CourseScrollSwatch.extent = "250 "@ (%currcount+1)*112;
	MiniGolf_Menu.position = "0 1";
}
function MiniGolf_SelectCourse(%index)
{
	Minigolf_PlayCourse.setVisible(1);
	Minigolf_CourseIcon.setVisible(1);
	Minigolf_CourseIcon.mColor = "255 255 255 0";
	Minigolf_FadeImageIn(Minigolf_CourseIcon);

	$MGC::SelectedCourseName = MiniGolf_CourseScrollSwatch.getObject(%index).courseName;

	%file = "Add-ons/Client_Minigolf/courseIcons/"@ $MGC::SelectedCourseName @".png";
	if(isFile(%file))
		Minigolf_CourseIcon.setBitmap(%file);
	else
		Minigolf_CourseIcon.setBitmap("add-ons/Client_Minigolf/courseIcons/default.png");
	%coursecount = Minigolf_CourseScrollSwatch.getCount();
	for(%a=0;%a<%coursecount;%a++)
	{
		%obj = Minigolf_CourseScrollSwatch.getObject(%a);
		%y = getword(%obj.position,1);
		if(%a == %index)
		{
			%obj.position = "8 "@ %y;
			%obj.color = $MGC::CourseHLColor;
		}
		else
		{
			%obj.position = "2 "@ %y;
			%obj.color = $MGC::CourseBGColor;
		}
	}
	Minigolf_PlayCourse.position = "25 290";
	schedule(400,0,"Minigolf_SlideButtonIn",Minigolf_PlayCourse,25,220);
}
function Minigolf_PlayCourse()
{
	commandToServer('MGC_playCourse',$MGC::SelectedCourseName);
}
function Minigolf_SelectPlayerList()
{
	%value = Minigolf_playerList.getValue();
	$MGC::SelectedPlayer = getField(%value,0);
	if($MGC::CurrentGroup == 2979)
		Minigolf_InviteToGroupButton.setText("Create Group >>");
	else if(getField(%value,1) != $Mgc::CurrentGroup)
		Minigolf_InviteToGroupButton.setText("Invite to Group >>");
	Minigolf_InviteToGroupButton.setVisible(1);
}
function Minigolf_SelectGroupList()
{
	%value = Minigolf_GroupList.getValue();
	$MGC::SelectedGroupPlayer = getField(%value,0);
	if(getField(%value,1) == $MGC::CurrentGroup)	
		Minigolf_RemoveFromGroupButton.setText("Delete Group");
	else
		Minigolf_RemoveFromGroupButton.setText("<< Remove");
	Minigolf_RemoveFromGroupButton.setVisible(1);
}
function Minigolf_InviteToGroup()
{
	commandToServer('MGC_InviteToGroup',$MGC::SelectedPlayer);
}
function Minigolf_RemoveFromGroup()
{
	commandToserver('MGC_RemoveFromGroup',$MGC::SelectedGroupPlayer);
}
function Minigolf_InviteBLID()
{
	commandToServer('MGC_InviteToGroup',Minigolf_EnterBLID.getValue());
}
function ClientCmdMGC_GroupListInit(%yourgroup)
{
	$MGC::CurrentGroup = %yourgroup;
	if(%yourgroup == 2979)
	{
		Minigolf_InviteToGroupButton.setText("Create Group >>");
		Minigolf_InviteToGroupButton.setVisible(1);
	}
	else
	{
		Minigolf_InviteToGroupButton.setText("Invite to Group >>");
		Minigolf_InviteToGroupButton.setVisible(0);
	}
	Minigolf_GroupList.clear();
	Minigolf_PlayerList.clear();
	Minigolf_RemoveFromGroupButton.setVisible(0);
}
function ClientCmdMGC_AddPlayer(%name,%blid,%group)
{
	Minigolf_PlayerList.addRow(1,%name TAB %blid);
	if(%group == $MGC::CurrentGroup)
		Minigolf_GroupList.addRow(1,%name TAB %blid);
}
function ClientCmdMGC_LeaderboardInit()
{
	Minigolf_YourRecords.clear();
	Minigolf_ServerRecords.clear();
}
function ClientCmdMGC_AddLeaderBoardMap(%map,%name,%blid,%score,%time,%yourdata)
{
	%yourscore = getWord(%yourdata,0);
	%yourtime = getWord(%yourdata,1);
	%minutes = mFloor(%yourtime/60);
	%seconds = %yourtime-(%minutes*60);
	%serverminutes = mFloor(%time/60);
	%serverseconds = %time-(%serverminutes*60);
	Minigolf_ServerRecords.addRow(1,%map TAB %name @" ("@ %blid @")"TAB %score TAB %serverminutes @"m"@ %serverseconds @"s");
	Minigolf_YourRecords.addRow(1,%map TAB %yourscore TAB %minutes @"m"@ %seconds @"s");
}