if( !isObject( MinigolfPowerProgress ) )
{
	new GuiControlProfile( MinigolfPowerProgress : GuiProgressProfile )
	{
		fillColor = "255 255 255 255";
		
		border = 1;
		borderColor = "0 0 0 255";
		borderThickness = 2;
	};
}

if( !isObject( MGCHUD_HoleText ) )
{
	new GuiControlProfile( MGCHUD_HoleText : BlockChatTextSize5Profile )
	{
		fontColors[ 0 ] = "255 255 255 255";
		fontOutlineColor = "0 0 0 255";

		fontType = "Impact";
		fontSize = 45;

		justify = "center";
	};
}

if( !isObject( MGCHUD_ParText ) )
{
	new GuiControlProfile( MGCHUD_ParText : MGCHUD_HoleText )
	{
		fontColors[ 0 ] = "255 255 255 255";
		fontOutlineColor = "124 166 24 255";
	};
}

if( !isObject( MGCHUD_StrokeText ) )
{
	new GuiControlProfile( MGCHUD_StrokeText : MGCHUD_HoleText )
	{
		fontColors[ 0 ] = "255 255 255 255";
		fontOutlineColor = "46 93 131 255";

		fontSize = 72;
	};
}

$ninePlusTen = 21;
$onePlusTwo = "fish";

if( !isObject( MGCScore_HeadText ) )
{
	new GuiControlProfile( MGCScore_HeadText : MGCHUD_HoleText )
	{
		fontColors[ 0 ] = "171 225 127";
		doFontOutline = false;

		fontType = "Verdana";
		fontSize = $ninePlusTen;
	};
}

if( !isObject( MGCScore_BodyWhiteText ) )
{
	new GuiControlProfile( MGCScore_BodyWhiteText : MGCScore_HeadText )
	{
		fontColors[ 0 ] = "255 255 255";
	};
}

if( !isObject( MGCScore_BodyRedText ) )
{
	new GuiControlProfile( MGCScore_BodyRedText : MGCScore_HeadText )
	{
		fontColors[ 0 ] = "255 144 155";
	};
}

if( !isObject( MGCScore_BodyNameText ) )
{
	new GuiControlProfile( MGCScore_BodyNameText : MGCScore_HeadText )
	{
		fontColors[ 0 ] = "255 255 255";

		justify = "left";
	};
}

if( !isObject( MGCScore_TitleText ) )
{
	new GuiControlProfile( MGCScore_TitleText : MGCScore_HeadText )
	{
		fontColors[ 0 ] = "255 255 255 255";
		fontOutlineColor = "0 0 0 255";
		doFontOutline = true;

		fontSize = 72;
	};
}

// 1.5 * desiredPixels = fontSize

//hole 45 font
//par 45 font
//strokes 72 font

if( !isObject( MGCScore_ScrollProfile ) )
{
	new GuiControlProfile( MGCScore_ScrollProfile : GuiScrollProfile )
	{
		opaque = false;
		border = false;

		fillColor = "255 255 255 0";
		fillColorHL = "171 171 171 0";
		fillColorNA = "171 171 171 0";

		bitmap = "Add-Ons/Client_Minigolf/res/img/scroll";
	};
}

if( !isObject( MGC_VoteButtonText ) )
{
	new GuiControlProfile( MGC_VoteButtonText )
	{
		fontColor = "250 252 251";
		fontSize = 14;
		fontType = "Arial";
		justify = "Left";
		doFontOutline = false;
	
		textOffset = "8 0";
	};
}
if(!isObject(MGC_MenuCenter))
{
	new GuiControlProfile(MGC_MenuCenter)
	{
		fontSize = 20;
		fontType = "Verdana";
		justify = "Center";

		fontColor = "255 255 255 255";
		fontColors[1] = "255 64 64";  
		fontColors[2] = "255 255 64"; 
		fontColors[3] = "192 192 192";
		fontColorLink = "0 255 255 255";
		fontColorLinkHL = "0 0 0 255";
		doFontOutline = 1;
		fontOutlineColor = "0 0 0 128";
	};
}
if(!isObject(MGC_MenuCredits))
{
	new GuiControlProfile(MGC_MenuCredits)
	{
		fontSize = 14;
		fontType = "Verdana";
		justify = "Center";

		fontColor = "255 255 255 255";
		fontColors[1] = "255 64 64";  
		fontColors[2] = "255 255 64"; 
		fontColors[3] = "192 192 192";
		fontColorLink = "0 255 255 255";
		fontColorLinkHL = "0 0 0 255";
		doFontOutline = 1;
		fontOutlineColor = "0 0 0 128";
	};
}
if(!isObject(MGC_MenuDescription))
{
	new GuiControlProfile(MGC_MenuDescription)
	{
		fontSize = 14;
		fontType = "Verdana";
		justify = "Center";

		fontColor = "255 255 255 255";
		fontColors[1] = "255 64 64";  
		fontColors[2] = "255 255 64"; 
		fontColors[3] = "192 192 192";
		fontColorLink = "0 255 255 255";
		fontColorLinkHL = "0 0 0 255";
		doFontOutline = 1;
		fontOutlineColor = "0 0 0 128";
	};
}
if(!isObject(MGC_MenuLeft))
{
	new GuiControlProfile(MGC_MenuLeft)
	{
		fontSize = 14;
		fontType = "Verdana";
		justify = "Left";

		fontColor = "255 255 255 255";
		fontColors[1] = "255 64 64";  
		fontColors[2] = "255 255 64"; 
		fontColors[3] = "192 192 192";
		fontColorLink = "0 255 255 255";
		fontColorLinkHL = "0 0 0 255";
		doFontOutline = 1;
		fontOutlineColor = "0 0 0 128";
	};
}
if(!isObject(MGC_MenuRight))
{
	new GuiControlProfile(MGC_MenuRight)
	{
		fontSize = 14;
		fontType = "Verdana";
		justify = "Right";

		fontColor = "255 255 255 255";
		fontColors[1] = "255 64 64";  
		fontColors[2] = "255 255 64"; 
		fontColors[3] = "192 192 192";
		fontColorLink = "0 255 255 255";
		fontColorLinkHL = "0 0 0 255";
		doFontOutline = 1;
		fontOutlineColor = "0 0 0 128";
	};
}
